Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/pjsystest/systest.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/pjsystest/systest.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/pjsystest/systest.c	(revision 3392)
@@ -651,5 +651,5 @@
     pjmedia_frame frm;
     short *buf;
-    unsigned i, samples_per_frame, read, len;
+    unsigned i, clock_rate, samples_per_frame, read, len;
     unsigned start_pos;
     pj_bool_t first;
@@ -661,5 +661,6 @@
     *lat_max = 0;
 
-    samples_per_frame = wav->info.samples_per_frame;
+    samples_per_frame = PJMEDIA_PIA_SPF(&wav->info);
+    clock_rate = PJMEDIA_PIA_SRATE(&wav->info);
     frm.buf = pj_pool_alloc(pool, samples_per_frame * 2);
     frm.size = samples_per_frame * 2;
@@ -678,5 +679,5 @@
     }
 
-    if (read < 2 * wav->info.clock_rate) {
+    if (read < 2 * clock_rate) {
 	systest_perror("The WAV file is too short", PJ_SUCCESS);
 	return -1;
@@ -686,10 +687,10 @@
      * (keypad press, etc.)
      */
-    pjmedia_zero_samples(buf, wav->info.clock_rate / 2);
+    pjmedia_zero_samples(buf, clock_rate / 2);
 
     /* Loop to calculate latency */
     start_pos = 0;
     first = PJ_TRUE;
-    while (start_pos < len/2 - wav->info.clock_rate) {
+    while (start_pos < len/2 - clock_rate) {
 	int max_signal = 0;
 	unsigned max_signal_pos = start_pos;
@@ -699,5 +700,5 @@
 
 	/* Get the largest signal in the next 0.7s */
-	for (i=start_pos; i<start_pos + wav->info.clock_rate * 700 / 1000; ++i) {
+	for (i=start_pos; i<start_pos + clock_rate * 700 / 1000; ++i) {
 	    if (abs(buf[i]) > max_signal) {
 		max_signal = abs(buf[i]);
@@ -707,10 +708,10 @@
 
 	/* Advance 10ms from max_signal_pos */
-	pos = max_signal_pos + 10 * wav->info.clock_rate / 1000;
+	pos = max_signal_pos + 10 * clock_rate / 1000;
 
 	/* Get the largest signal in the next 800ms */
 	max_signal = 0;
 	max_echo_pos = pos;
-	for (i=pos; i<pos+wav->info.clock_rate * 8 / 10; ++i) {
+	for (i=pos; i<pos+clock_rate * 8 / 10; ++i) {
 	    if (abs(buf[i]) > max_signal) {
 		max_signal = abs(buf[i]);
@@ -719,10 +720,10 @@
 	}
 
-	lat = (max_echo_pos - max_signal_pos) * 1000 / wav->info.clock_rate;
+	lat = (max_echo_pos - max_signal_pos) * 1000 / clock_rate;
 
 #if 0
 	PJ_LOG(4,(THIS_FILE, "Signal at %dms, echo at %d ms, latency %d ms",
-		  max_signal_pos * 1000 / wav->info.clock_rate,
-		  max_echo_pos * 1000 / wav->info.clock_rate,
+		  max_signal_pos * 1000 / clock_rate,
+		  max_echo_pos * 1000 / clock_rate,
 		  lat));
 #endif
@@ -737,8 +738,8 @@
 	/* Advance next loop */
 	if (first) {
-	    start_pos = max_signal_pos + wav->info.clock_rate * 9 / 10;
+	    start_pos = max_signal_pos + clock_rate * 9 / 10;
 	    first = PJ_FALSE;
 	} else {
-	    start_pos += wav->info.clock_rate;
+	    start_pos += clock_rate;
 	}
     }
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/aectest.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/aectest.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/aectest.c	(revision 3392)
@@ -198,5 +198,5 @@
 
     /* play and rec WAVs must have the same clock rate */
-    if (wav_play->info.clock_rate != wav_rec->info.clock_rate) {
+    if (PJMEDIA_PIA_SRATE(&wav_play->info) != PJMEDIA_PIA_SRATE(&wav_rec->info)) {
 	puts("Error: clock rate mismatch in the WAV files");
 	return 1;
@@ -204,5 +204,5 @@
 
     /* .. and channel count */
-    if (wav_play->info.channel_count != wav_rec->info.channel_count) {
+    if (PJMEDIA_PIA_CCNT(&wav_play->info) != PJMEDIA_PIA_CCNT(&wav_rec->info)) {
 	puts("Error: clock rate mismatch in the WAV files");
 	return 1;
@@ -211,8 +211,8 @@
     /* Create output wav */
     status = pjmedia_wav_writer_port_create(pool, argv[pj_optind+2],
-					    wav_play->info.clock_rate,
-					    wav_play->info.channel_count,
-					    wav_play->info.samples_per_frame,
-					    wav_play->info.bits_per_sample,
+					    PJMEDIA_PIA_SRATE(&wav_play->info),
+					    PJMEDIA_PIA_CCNT(&wav_play->info),
+					    PJMEDIA_PIA_SPF(&wav_play->info),
+					    PJMEDIA_PIA_BITS(&wav_play->info),
 					    0, 0, &wav_out);
     if (status != PJ_SUCCESS) {
@@ -222,7 +222,7 @@
 
     /* Create echo canceller */
-    status = pjmedia_echo_create2(pool, wav_play->info.clock_rate,
-				  wav_play->info.channel_count,
-				  wav_play->info.samples_per_frame,
+    status = pjmedia_echo_create2(pool, PJMEDIA_PIA_SRATE(&wav_play->info),
+				  PJMEDIA_PIA_CCNT(&wav_play->info),
+				  PJMEDIA_PIA_SPF(&wav_play->info),
 				  tail_ms, latency_ms,
 				  opt, &ec);
@@ -234,10 +234,10 @@
 
     /* Processing loop */
-    play_frame.buf = pj_pool_alloc(pool, wav_play->info.samples_per_frame<<1);
-    rec_frame.buf = pj_pool_alloc(pool, wav_play->info.samples_per_frame<<1);
+    play_frame.buf = pj_pool_alloc(pool, PJMEDIA_PIA_SPF(&wav_play->info)<<1);
+    rec_frame.buf = pj_pool_alloc(pool, PJMEDIA_PIA_SPF(&wav_play->info)<<1);
     pj_get_timestamp(&t0);
     for (i=0; i < repeat; ++i) {
 	for (;;) {
-	    play_frame.size = wav_play->info.samples_per_frame << 1;
+	    play_frame.size = PJMEDIA_PIA_SPF(&wav_play->info) << 1;
 	    status = pjmedia_port_get_frame(wav_play, &play_frame);
 	    if (status != PJ_SUCCESS)
@@ -246,5 +246,5 @@
 	    status = pjmedia_echo_playback(ec, (short*)play_frame.buf);
 
-	    rec_frame.size = wav_play->info.samples_per_frame << 1;
+	    rec_frame.size = PJMEDIA_PIA_SPF(&wav_play->info) << 1;
 	    status = pjmedia_port_get_frame(wav_rec, &rec_frame);
 	    if (status != PJ_SUCCESS)
@@ -265,5 +265,5 @@
 
     i = pjmedia_wav_writer_port_get_pos(wav_out) / sizeof(pj_int16_t) * 1000 / 
-	(wav_out->info.clock_rate * wav_out->info.channel_count);
+	 (PJMEDIA_PIA_SRATE(&wav_out->info) * PJMEDIA_PIA_CCNT(&wav_out->info));
     PJ_LOG(3,(THIS_FILE, "Processed %3d.%03ds audio",
 	      i / 1000, i % 1000));
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/auddemo.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/auddemo.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/auddemo.c	(revision 3392)
@@ -145,5 +145,5 @@
 		break;
 	    }
-	    sprintf(bitrate, "%u", info.ext_fmt[i].bitrate);
+	    sprintf(bitrate, "%u", info.ext_fmt[i].det.aud.avg_bps);
 	    strcat(formats, bitrate);
 	    strcat(formats, " ");
@@ -277,8 +277,8 @@
 
     param.dir = PJMEDIA_DIR_CAPTURE;
-    param.clock_rate = wav->info.clock_rate;
-    param.samples_per_frame = wav->info.samples_per_frame;
-    param.channel_count = wav->info.channel_count;
-    param.bits_per_sample = wav->info.bits_per_sample;
+    param.clock_rate = PJMEDIA_PIA_SRATE(&wav->info);
+    param.samples_per_frame = PJMEDIA_PIA_SPF(&wav->info);
+    param.channel_count = PJMEDIA_PIA_CCNT(&wav->info);
+    param.bits_per_sample = PJMEDIA_PIA_BITS(&wav->info);
 
     status = pjmedia_aud_stream_create(&param, &wav_rec_cb, NULL, wav,
@@ -344,8 +344,8 @@
 
     param.dir = PJMEDIA_DIR_PLAYBACK;
-    param.clock_rate = wav->info.clock_rate;
-    param.samples_per_frame = wav->info.samples_per_frame;
-    param.channel_count = wav->info.channel_count;
-    param.bits_per_sample = wav->info.bits_per_sample;
+    param.clock_rate = PJMEDIA_PIA_SRATE(&wav->info);
+    param.samples_per_frame = PJMEDIA_PIA_SPF(&wav->info);
+    param.channel_count = PJMEDIA_PIA_CCNT(&wav->info);
+    param.bits_per_sample = PJMEDIA_PIA_BITS(&wav->info);
 
     status = pjmedia_aud_stream_create(&param, NULL, &wav_play_cb, wav,
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/jbsim.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/jbsim.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/jbsim.c	(revision 3392)
@@ -531,6 +531,6 @@
 
     /* Make sure stream and WAV parameters match */
-    if (g_app.tx_wav->info.clock_rate != g_app.tx->port->info.clock_rate ||
-	g_app.tx_wav->info.channel_count != g_app.tx->port->info.channel_count)
+    if (PJMEDIA_PIA_SRATE(&g_app.tx_wav->info) != PJMEDIA_PIA_SRATE(&g_app.tx->port->info) ||
+	PJMEDIA_PIA_CCNT(&g_app.tx_wav->info) != PJMEDIA_PIA_CCNT(&g_app.tx->port->info))
     {
 	jbsim_perror("Error: Input WAV file has different clock rate "
@@ -555,8 +555,8 @@
     status = pjmedia_wav_writer_port_create(g_app.pool, 
 					    g_app.cfg.rx_wav_out,
-					    g_app.rx->port->info.clock_rate,
-					    g_app.rx->port->info.channel_count,
-					    g_app.rx->port->info.samples_per_frame,
-					    g_app.rx->port->info.bits_per_sample,
+					    PJMEDIA_PIA_SRATE(&g_app.rx->port->info),
+					    PJMEDIA_PIA_CCNT(&g_app.rx->port->info),
+					    PJMEDIA_PIA_SPF(&g_app.rx->port->info),
+					    PJMEDIA_PIA_BITS(&g_app.rx->port->info),
 					    0,
 					    0,
@@ -571,6 +571,6 @@
     g_app.framebuf = (pj_int16_t*)
 		     pj_pool_alloc(g_app.pool,
-				   MAX(g_app.rx->port->info.samples_per_frame,
-				       g_app.tx->port->info.samples_per_frame) * sizeof(pj_int16_t));
+				   MAX(PJMEDIA_PIA_SPF(&g_app.rx->port->info),
+				       PJMEDIA_PIA_SPF(&g_app.tx->port->info)) * sizeof(pj_int16_t));
 
 
@@ -595,5 +595,5 @@
     frame.type = PJMEDIA_FRAME_TYPE_AUDIO;
     frame.buf = g_app.framebuf;
-    frame.size = dst->info.samples_per_frame * 2;
+    frame.size = PJMEDIA_PIA_SPF(&dst->info) * 2;
     
     status = pjmedia_port_get_frame(src, &frame);
@@ -602,6 +602,6 @@
     if (status!= PJ_SUCCESS || frame.type != PJMEDIA_FRAME_TYPE_AUDIO) {
 	frame.buf = g_app.framebuf;
-	pjmedia_zero_samples(g_app.framebuf, src->info.samples_per_frame);
-	frame.size = src->info.samples_per_frame * 2;
+	pjmedia_zero_samples(g_app.framebuf, PJMEDIA_PIA_SPF(&src->info));
+	frame.size = PJMEDIA_PIA_SPF(&src->info) * 2;
 	if (has_frame)
 	    *has_frame = PJ_FALSE;
@@ -629,6 +629,6 @@
 
     /* packet interval, without jitter */
-    pkt_interval = port->info.samples_per_frame * 1000 /
-		   port->info.clock_rate;
+    pkt_interval = PJMEDIA_PIA_SPF(&port->info) * 1000 /
+		   PJMEDIA_PIA_SRATE(&port->info);
 
     while (PJ_TIME_VAL_GTE(*t, strm->state.tx.next_schedule)) {
@@ -778,6 +778,6 @@
     long pkt_interval;
 
-    pkt_interval = port->info.samples_per_frame * 1000 /
-		   port->info.clock_rate *
+    pkt_interval = PJMEDIA_PIA_SPF(&port->info) * 1000 /
+		   PJMEDIA_PIA_SRATE(&port->info) *
 		   g_app.cfg.rx_snd_burst;
 
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/latency.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/latency.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/latency.c	(revision 3392)
@@ -61,5 +61,5 @@
 	     lat_max = 0;
 
-    samples_per_frame = wav->info.samples_per_frame;
+    samples_per_frame = PJMEDIA_PIA_SPF(&wav->info);
     frm.buf = pj_pool_alloc(pool, samples_per_frame * 2);
     frm.size = samples_per_frame * 2;
@@ -77,5 +77,5 @@
     }
 
-    if (read < 2 * wav->info.clock_rate) {
+    if (read < 2 * PJMEDIA_PIA_SRATE(&wav->info)) {
 	puts("Error: too short");
 	return -1;
@@ -83,5 +83,5 @@
 
     start_pos = 0;
-    while (start_pos < len/2 - wav->info.clock_rate) {
+    while (start_pos < len/2 - PJMEDIA_PIA_SRATE(&wav->info)) {
 	int max_signal = 0;
 	unsigned max_signal_pos = start_pos;
@@ -91,5 +91,5 @@
 
 	/* Get the largest signal in the next 0.7s */
-	for (i=start_pos; i<start_pos + wav->info.clock_rate * 700 / 1000; ++i) {
+	for (i=start_pos; i<start_pos + PJMEDIA_PIA_SRATE(&wav->info) * 700 / 1000; ++i) {
 	    if (abs(buf[i]) > max_signal) {
 		max_signal = abs(buf[i]);
@@ -99,10 +99,10 @@
 
 	/* Advance 10ms from max_signal_pos */
-	pos = max_signal_pos + 10 * wav->info.clock_rate / 1000;
+	pos = max_signal_pos + 10 * PJMEDIA_PIA_SRATE(&wav->info) / 1000;
 
 	/* Get the largest signal in the next 500ms */
 	max_signal = 0;
 	max_echo_pos = pos;
-	for (i=pos; i<pos+wav->info.clock_rate/2; ++i) {
+	for (i=pos; i<pos+PJMEDIA_PIA_SRATE(&wav->info)/2; ++i) {
 	    if (abs(buf[i]) > max_signal) {
 		max_signal = abs(buf[i]);
@@ -111,5 +111,5 @@
 	}
 
-	lat = (max_echo_pos - max_signal_pos) * 1000 / wav->info.clock_rate;
+	lat = (max_echo_pos - max_signal_pos) * 1000 / PJMEDIA_PIA_SRATE(&wav->info);
 	
 #if 0
@@ -125,5 +125,5 @@
 
 	/* Advance next loop */
-	start_pos += wav->info.clock_rate;
+	start_pos += PJMEDIA_PIA_SRATE(&wav->info);
     }
 
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/level.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/level.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/level.c	(revision 3392)
@@ -125,5 +125,5 @@
     }
 
-    if (file_port->info.samples_per_frame > NSAMPLES) {
+    if (PJMEDIA_PIA_SPF(&file_port->info) > NSAMPLES) {
 	app_perror(THIS_FILE, "WAV clock rate is too big", PJ_EINVAL);
 	return 1;
@@ -146,9 +146,9 @@
 
 	level32 = pjmedia_calc_avg_signal(framebuf, 
-					  file_port->info.samples_per_frame);
+					  PJMEDIA_PIA_SPF(&file_port->info));
 	level = pjmedia_linear2ulaw(level32) ^ 0xFF;
 
-	ms = i * 1000 * file_port->info.samples_per_frame /
-			file_port->info.clock_rate;
+	ms = i * 1000 * PJMEDIA_PIA_SPF(&file_port->info) /
+		PJMEDIA_PIA_SRATE(&file_port->info);
 	printf("%03d.%03d\t%7d\t%7d\n", 
 	        ms/1000, ms%1000, level, level32);
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/mix.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/mix.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/mix.c	(revision 3392)
@@ -182,5 +182,5 @@
 	len = pjmedia_wav_player_get_len(wav_input[i].port);
 	len = (pj_ssize_t)(len * 1.0 * clock_rate / 
-			    wav_input[i].port->info.clock_rate);
+			   PJMEDIA_PIA_SRATE(&wav_input[i].port->info));
 	if (len > (pj_ssize_t)longest)
 	    longest = len;
@@ -200,5 +200,5 @@
 
 	frame.buf = framebuf;
-	frame.size = cp->info.samples_per_frame * 2;
+	frame.size = PJMEDIA_PIA_SPF(&cp->info) * 2;
 	pj_assert(frame.size <= sizeof(framebuf));
 	
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/pcaputil.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/pcaputil.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/pcaputil.c	(revision 3392)
@@ -88,5 +88,5 @@
         if (pos >= 0) {
             unsigned msec;
-            msec = pos / 2 * 1000 / app.wav->info.clock_rate;
+            msec = pos / 2 * 1000 / PJMEDIA_PIA_SRATE(&app.wav->info);
             printf("Written: %dm:%02ds.%03d\n",
                     msec / 1000 / 60,
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/playfile.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/playfile.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/playfile.c	(revision 3392)
@@ -140,8 +140,8 @@
 		 pool,				    /* pool		    */
 		 -1,				    /* use default dev.	    */
-		 file_port->info.clock_rate,	    /* clock rate.	    */
-		 file_port->info.channel_count,	    /* # of channels.	    */
-		 file_port->info.samples_per_frame, /* samples per frame.   */
-		 file_port->info.bits_per_sample,   /* bits per sample.	    */
+		 PJMEDIA_PIA_SRATE(&file_port->info),/* clock rate.	    */
+		 PJMEDIA_PIA_CCNT(&file_port->info),/* # of channels.	    */
+		 PJMEDIA_PIA_SPF(&file_port->info), /* samples per frame.   */
+		 PJMEDIA_PIA_BITS(&file_port->info),/* bits per sample.	    */
 		 0,				    /* options		    */
 		 &snd_port			    /* returned port	    */
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/playsine.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/playsine.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/playsine.c	(revision 3392)
@@ -87,5 +87,5 @@
 
     /* Get number of samples */
-    count = frame->size / 2 / port->info.channel_count;
+    count = frame->size / 2 / PJMEDIA_PIA_CCNT(&port->info);
 
     left = 0;
@@ -96,5 +96,5 @@
 	++left;
 
-	if (port->info.channel_count == 2) {
+	if (PJMEDIA_PIA_CCNT(&port->info) == 2) {
 	    *samples++ = sine->samples[right];
 	    right += 2; /* higher pitch so we can distinguish left and right. */
@@ -127,4 +127,5 @@
     unsigned i;
     unsigned count;
+    pj_str_t name;
     port_data *sine;
 
@@ -136,15 +137,10 @@
 
     /* Fill in port info. */
-    port->info.bits_per_sample = 16;
-    port->info.channel_count = channel_count;
-    port->info.encoding_name = pj_str("pcm");
-    port->info.has_info = 1;
-    port->info.name = pj_str("sine generator");
-    port->info.need_info = 0;
-    port->info.pt = 0xFF;
-    port->info.clock_rate = sampling_rate;
-    port->info.samples_per_frame = sampling_rate * 20 / 1000 * channel_count;
-    port->info.bytes_per_frame = port->info.samples_per_frame * 2;
-    port->info.type = PJMEDIA_TYPE_AUDIO;
+    name = pj_str("sine generator");
+    pjmedia_port_info_init(&port->info, &name,
+			   PJMEDIA_PORT_SIGNATURE('s', 'i', 'n', 'e'),
+			   sampling_rate,
+			   channel_count,
+			   16, sampling_rate * 20 / 1000 * channel_count);
     
     /* Set the function to feed frame */
@@ -155,5 +151,5 @@
 
     /* Create samples */
-    count = port->info.samples_per_frame / channel_count;
+    count = PJMEDIA_PIA_SPF(&port->info) / channel_count;
     sine->samples = pj_pool_alloc(pool, count * sizeof(pj_int16_t));
     PJ_ASSERT_RETURN(sine->samples != NULL, PJ_ENOMEM);
@@ -245,8 +241,8 @@
 		 pool,				    /* pool		    */
 		 -1,				    /* use default dev.	    */
-		 sine_port->info.clock_rate,	    /* clock rate.	    */
-		 sine_port->info.channel_count,	    /* # of channels.	    */
-		 sine_port->info.samples_per_frame, /* samples per frame.   */
-		 sine_port->info.bits_per_sample,   /* bits per sample.	    */
+		 PJMEDIA_PIA_SRATE(&sine_port->info),/* clock rate.	    */
+		 PJMEDIA_PIA_CCNT(&sine_port->info),/* # of channels.	    */
+		 PJMEDIA_PIA_SPF(&sine_port->info), /* samples per frame.   */
+		 PJMEDIA_PIA_BITS(&sine_port->info),/* bits per sample.	    */
 		 0,				    /* options		    */
 		 &snd_port			    /* returned port	    */
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/recfile.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/recfile.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/recfile.c	(revision 3392)
@@ -135,8 +135,8 @@
 		 pool,				    /* pool		    */
 		 -1,				    /* use default dev.	    */
-		 file_port->info.clock_rate,	    /* clock rate.	    */
-		 file_port->info.channel_count,	    /* # of channels.	    */
-		 file_port->info.samples_per_frame, /* samples per frame.   */
-		 file_port->info.bits_per_sample,   /* bits per sample.	    */
+		 PJMEDIA_PIA_SRATE(&file_port->info),/* clock rate.	    */
+		 PJMEDIA_PIA_CCNT(&file_port->info),/* # of channels.	    */
+		 PJMEDIA_PIA_SPF(&file_port->info), /* samples per frame.   */
+		 PJMEDIA_PIA_BITS(&file_port->info),/* bits per sample.	    */
 		 0,				    /* options		    */
 		 &snd_port			    /* returned port	    */
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/resampleplay.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/resampleplay.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/resampleplay.c	(revision 3392)
@@ -130,5 +130,5 @@
 
     /* File must have same number of channels. */
-    if (file_port->info.channel_count != (unsigned)channel_count) {
+    if (PJMEDIA_PIA_CCNT(&file_port->info) != (unsigned)channel_count) {
 	PJ_LOG(3,(THIS_FILE, "Error: file has different number of channels. "
 			     "Perhaps you'd need -c option?"));
@@ -187,5 +187,6 @@
 
     printf("Playing %s at sampling rate %d (original file sampling rate=%d)\n",
-	   argv[pj_optind], sampling_rate, file_port->info.clock_rate);
+	   argv[pj_optind], sampling_rate,
+	   PJMEDIA_PIA_SRATE(&file_port->info));
     puts("");
     puts("Press <ENTER> to stop playing and quit");
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/simpleua.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/simpleua.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/simpleua.c	(revision 3392)
@@ -707,8 +707,8 @@
 		    inv->pool,				/* pool		    */
 		    -1,					/* sound dev id	    */
-		    media_port->info.clock_rate,	/* clock rate	    */
-		    media_port->info.channel_count,	/* channel count    */
-		    media_port->info.samples_per_frame, /* samples per frame*/
-		    media_port->info.bits_per_sample,   /* bits per sample  */
+		    PJMEDIA_PIA_SRATE(&media_port->info),/* clock rate	    */
+		    PJMEDIA_PIA_CCNT(&media_port->info),/* channel count    */
+		    PJMEDIA_PIA_SPF(&media_port->info), /* samples per frame*/
+		    PJMEDIA_PIA_BITS(&media_port->info),/* bits per sample  */
 		    0,					/* options	    */
 		    &g_snd_player);
@@ -716,8 +716,8 @@
 	app_perror( THIS_FILE, "Unable to create sound player", status);
 	PJ_LOG(3,(THIS_FILE, "%d %d %d %d",
-	    	    media_port->info.clock_rate,	/* clock rate	    */
-		    media_port->info.channel_count,	/* channel count    */
-		    media_port->info.samples_per_frame, /* samples per frame*/
-		    media_port->info.bits_per_sample    /* bits per sample  */
+		    PJMEDIA_PIA_SRATE(&media_port->info),/* clock rate	    */
+		    PJMEDIA_PIA_CCNT(&media_port->info),/* channel count    */
+		    PJMEDIA_PIA_SPF(&media_port->info), /* samples per frame*/
+		    PJMEDIA_PIA_BITS(&media_port->info) /* bits per sample  */
 	    ));
 	return;
@@ -733,8 +733,8 @@
 		    inv->pool,				/* pool		    */
 		    -1,					/* sound dev id	    */
-		    media_port->info.clock_rate,	/* clock rate	    */
-		    media_port->info.channel_count,	/* channel count    */
-		    media_port->info.samples_per_frame, /* samples per frame*/
-		    media_port->info.bits_per_sample,   /* bits per sample  */
+		    PJMEDIA_PIA_SRATE(&media_port->info),/* clock rate	    */
+		    PJMEDIA_PIA_CCNT(&media_port->info),/* channel count    */
+		    PJMEDIA_PIA_SPF(&media_port->info), /* samples per frame*/
+		    PJMEDIA_PIA_BITS(&media_port->info),/* bits per sample  */
 		    0,					/* options	    */
 		    &g_snd_rec);
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/stereotest.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/stereotest.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/stereotest.c	(revision 3392)
@@ -190,9 +190,9 @@
 		     pool,				/* pool		      */
 		     dev_id,				/* device id.	      */
-		     file_port->info.clock_rate,	/* clock rate.	      */
+		     PJMEDIA_PIA_SRATE(&file_port->info),/* clock rate.	      */
 		     snd_ch_cnt,			/* # of channels.     */
 		     snd_ch_cnt * PTIME *		/* samples per frame. */
-		     file_port->info.clock_rate / 1000,
-		     file_port->info.bits_per_sample,   /* bits per sample.   */
+		     PJMEDIA_PIA_SRATE(&file_port->info) / 1000,
+		     PJMEDIA_PIA_BITS(&file_port->info),/* bits per sample.   */
 		     0,					/* options	      */
 		     &snd_port				/* returned port      */
@@ -203,5 +203,5 @@
 	}
 
-	if (snd_ch_cnt != file_port->info.channel_count) {
+	if (snd_ch_cnt != PJMEDIA_PIA_CCNT(&file_port->info)) {
 	    status = pjmedia_stereo_port_create( pool,
 						 file_port,
@@ -290,7 +290,7 @@
 
     printf("Mode = %s\n", (mode == MODE_PLAY? "playing" : "recording") );
-    printf("File  port channel count = %d\n", file_port->info.channel_count);
+    printf("File  port channel count = %d\n", PJMEDIA_PIA_CCNT(&file_port->info));
     printf("Sound port channel count = %d\n", 
-	   pjmedia_snd_port_get_port(snd_port)->info.channel_count);
+	    PJMEDIA_PIA_CCNT(&pjmedia_snd_port_get_port(snd_port)->info));
     puts("");
     puts("Press <ENTER> to stop and quit");
Index: pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/streamutil.c
===================================================================
--- pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/streamutil.c	(revision 3391)
+++ pjproject/branches/projects/2.0-dev/pjsip-apps/src/samples/streamutil.c	(revision 3392)
@@ -506,6 +506,5 @@
 	unsigned wav_ptime;
 
-	wav_ptime = stream_port->info.samples_per_frame * 1000 /
-		    stream_port->info.clock_rate;
+	wav_ptime = PJMEDIA_PIA_PTIME(&stream_port->info);
 	status = pjmedia_wav_player_port_create(pool, play_file, wav_ptime,
 						0, -1, &play_file_port);
@@ -533,8 +532,8 @@
 
 	status = pjmedia_wav_writer_port_create(pool, rec_file,
-					        stream_port->info.clock_rate,
-						stream_port->info.channel_count,
-						stream_port->info.samples_per_frame,
-						stream_port->info.bits_per_sample,
+					        PJMEDIA_PIA_SRATE(&stream_port->info),
+					        PJMEDIA_PIA_CCNT(&stream_port->info),
+					        PJMEDIA_PIA_SPF(&stream_port->info),
+					        PJMEDIA_PIA_BITS(&stream_port->info),
 						0, 0, &rec_file_port);
 	if (status != PJ_SUCCESS) {
@@ -563,22 +562,22 @@
 	if (dir == PJMEDIA_DIR_ENCODING_DECODING)
 	    status = pjmedia_snd_port_create(pool, -1, -1, 
-					stream_port->info.clock_rate,
-					stream_port->info.channel_count,
-					stream_port->info.samples_per_frame,
-					stream_port->info.bits_per_sample,
+					PJMEDIA_PIA_SRATE(&stream_port->info),
+					PJMEDIA_PIA_CCNT(&stream_port->info),
+					PJMEDIA_PIA_SPF(&stream_port->info),
+					PJMEDIA_PIA_BITS(&stream_port->info),
 					0, &snd_port);
 	else if (dir == PJMEDIA_DIR_ENCODING)
 	    status = pjmedia_snd_port_create_rec(pool, -1, 
-					stream_port->info.clock_rate,
-					stream_port->info.channel_count,
-					stream_port->info.samples_per_frame,
-					stream_port->info.bits_per_sample,
+					PJMEDIA_PIA_SRATE(&stream_port->info),
+					PJMEDIA_PIA_CCNT(&stream_port->info),
+					PJMEDIA_PIA_SPF(&stream_port->info),
+					PJMEDIA_PIA_BITS(&stream_port->info),
 					0, &snd_port);
 	else
 	    status = pjmedia_snd_port_create_player(pool, -1, 
-					stream_port->info.clock_rate,
-					stream_port->info.channel_count,
-					stream_port->info.samples_per_frame,
-					stream_port->info.bits_per_sample,
+					PJMEDIA_PIA_SRATE(&stream_port->info),
+					PJMEDIA_PIA_CCNT(&stream_port->info),
+					PJMEDIA_PIA_SPF(&stream_port->info),
+					PJMEDIA_PIA_BITS(&stream_port->info),
 					0, &snd_port);
 
@@ -758,9 +757,7 @@
 
 
-    printf(" Info: audio %.*s@%dHz, %dms/frame, %sB/s (%sB/s +IP hdr)\n",
-   	(int)port->info.encoding_name.slen,
-	port->info.encoding_name.ptr,
-	port->info.clock_rate,
-	port->info.samples_per_frame * 1000 / port->info.clock_rate,
+    printf(" Info: audio %dHz, %dms/frame, %sB/s (%sB/s +IP hdr)\n",
+	PJMEDIA_PIA_SRATE(&port->info),
+	PJMEDIA_PIA_PTIME(&port->info),
 	good_number(bps, (codec_param->info.avg_bps+7)/8),
 	good_number(ipbps, ((codec_param->info.avg_bps+7)/8) + 
